# Note:  This is loaded in the namespace
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {  ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_tuneFdbCurr { params } { 
       global SIDEList
       global ASICList0 ASICLIST1
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2] 
	set offsetMin -120 ;# [DAC]
	set offsetMax +120 ;# [DAC]
	set offsetStep 5   ;# [DAC]
	set deltaT 500;# [ms]
	
	# Start DAQ.
	do_getState
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if {[do_getState] != 1} {return "DAQ did not start" } 
	
	# Loop over individual side.
	foreach itrSide [set SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		# --
		# TO BE REMOVED.
		# Loop over PkTm and load offsets.
		foreach itrPkTm {14 126 254} {
		    # --
		    
		    # --
		    # TO BE RESTORED
		    # Set file name
		    #set fileName  /MIDAS/SpecData/R3B/TestData/
		    #append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
		    #append fileName "TuneFdbCurrCoarse-"
		    #append fileName "Side$itrSide-Asic$itrAsic.txt" 
		    # --
		    
		    # --
		    # TO BE REMOVED.
		    # Set PkTm.
		    set registerPkTm 4
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPkTm] $itrPkTm 
		    # Set file name.
		    set fileName  /MIDAS/SpecData/R3B/TestData/
		    append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
		    append fileName "TuneFdbCurrCoarse-"
		    append fileName "Side$itrSide-Asic$itrAsic-Reg4-$itrPkTm.txt"
		    # Load tuning.
		    set path /MIDAS/SpecData/R3B/TestData/calibrationFiles/asicV3/B30/
		    if {$itrAsic==1 && $itrPkTm==14} { 
		    	append path "2015-06-30-TuneEthCoarse-Side0-Asic1-Reg4-14-offset.txt"
		    } elseif {$itrAsic==1 && $itrPkTm==126} {
		    	append path "2015-06-30-TuneEthCoarse-Side0-Asic1-Reg4-126-offset.txt"
		    } elseif {$itrAsic==1 && $itrPkTm==254} {
		    	append path "2015-06-30-TuneEthCoarse-Side0-Asic1-Reg4-254-offset.txt"
		    } elseif {$itrAsic==5 && $itrPkTm==14} {
			append path "2015-06-30-TuneEthCoarse-Side0-Asic5-Reg4-14-offset.txt"
		    } elseif {$itrAsic==5 && $itrPkTm==126} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic5-Reg4-126-offset.txt"
		    } elseif {$itrAsic==5 && $itrPkTm==254} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic5-Reg4-254-offset.txt"
		    } elseif {$itrAsic==9 && $itrPkTm==14} {
		    	append path "2015-07-01-TuneEthCoarse-Side0-Asic9-Reg4-14-offset.txt"
		    } elseif {$itrAsic==9 && $itrPkTm==126} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic9-Reg4-126-offset.txt"
		    } elseif {$itrAsic==9 && $itrPkTm==254} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic9-Reg4-254-offset.txt"
		    } elseif {$itrAsic==13 && $itrPkTm==14} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic13-Reg4-14-offset.txt"
		    } elseif {$itrAsic==13 && $itrPkTm==126} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic13-Reg4-126-offset.txt"
		    } elseif {$itrAsic==13 && $itrPkTm==254} {
			append path "2015-07-01-TuneEthCoarse-Side0-Asic13-Reg4-254-offset.txt"
		    }
		    InsertLog "[do_loadOffsetEnTh $path]"
		    # --
		    
		    # Create file and set permissions.
		    set flagOpen [catch {open $fileName w} fileInput]
		    set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
		    if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
		    if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
		    
		    # Flush file header.
		    puts $fileInput "$itrSide $itrAsic $offsetMin $offsetMax $offsetStep"
		    flush $fileInput
		    
		    # Initialize EnTh to minimum (0x80)
		    set registerEth 15
		    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerEth] 0x80
		    # Load offsets.
		    
		    # Loop over individual channels.
		    set channelNumber 128
		    set channelIncrease 1
		    for {set itrChannel 0} {$itrChannel < $channelNumber} {set itrChannel [expr $itrChannel+$channelIncrease]} {
			
			# if { $itrChannel != 0 } { continue;}
			
			set valuePwr [expr 255 - int( pow (2,  $itrChannel - ( $itrChannel/8)*8 ) ) ]
			set registerPwr [expr 80 + ($itrChannel/8)]
			WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
			
			for {set itrOffset $offsetMin} {$itrOffset < 0} {set itrOffset [expr $itrOffset+$offsetStep]} {
			    set offsetValue [expr 127 + abs($itrOffset)]
			    set page 1
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + ($page << 8) + (128+$itrChannel) ] $offsetValue  
			    set valuePwr [expr 255 - int( pow (2,  $itrChannel - ( $itrChannel/8)*8 ) ) ]
			    set registerPwr [expr 80 + ($itrChannel/8)]
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
			    
			    # Wait for power up.
			    if {$itrOffset == $offsetMin} {after $deltaT}
			    
			    # Zero histo.
			    set fileName "E.$itrSide.$itrAsic.$itrChannel"
			    # This zeros the histogram.
			    if { [ZeroSpectrum $fileName] != 0 } { 
				return "Histograms E.$itrSide.$itrAsic.* were not created";}
			    
			    # Wait.
			    after $deltaT
			    
			    set plot  [do_analyseSpectra $itrSide $itrAsic $itrChannel]
			    set range [lindex $plot 0]
			    set data  [lindex $plot 1]
			    
			    puts $fileInput "$itrChannel $itrOffset $range"
			    puts $fileInput $data
			    flush $fileInput
			    
			    # Power off channel.
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
			    
			} ;# end of loop over offset.
			
			for {set itrOffset 0} {$itrOffset < [expr $offsetMax +$offsetStep]} {set itrOffset [expr $itrOffset+$offsetStep]} {
			    
			    set offsetValue $itrOffset
			    set page 1
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + ($page << 8) + (128+$itrChannel) ] $offsetValue 
			    set valuePwr [expr 255 - pow (2, $itrChannel - ($itrChannel/8)*8 ) ]
			    set registerPwr [expr 80 + ($itrChannel/8)]
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
			    # Zero histo.
			    set fileName "E.$itrSide.$itrAsic.$itrChannel"
			    # This zeros the histogram.
			    if { [ZeroSpectrum $fileName] != 0 } { 
				return "Histograms E.$itrSide.$itrAsic.* were not created";}
			    
			    # Wait.
			    after $deltaT
			    
			    set plot  [do_analyseSpectra $itrSide $itrAsic $itrChannel]
			    set range [lindex $plot 0]
			    set data  [lindex $plot 1]
			    
			    puts $fileInput "$itrChannel $itrOffset $range"
			    puts $fileInput $data
			    flush $fileInput
			    
			    # Power off channel.
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
			} ;# end loop over offset
			
		    } ;# end of loop over channel.
		    
		    # --
		    close $fileInput
		    
		    # --
		    # TO BE REMOVED.
		} ;# end loop over pktm.
		
	    } ;# end of loop over asic.
	}  ;#end of loop over side.
	
	return "Measurement complete."; 
    }
    
    proc do_tuneFdbCurrBis { params } { 
       global SIDEList
       global ASICList0 ASICLIST1
	
	do_loadOffset
	return;
	
	# It powers up 8 non-adjacent channels each time.
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	
	do_getState 
	# Start DAQ.
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 1 } {return "Daq not started properly.";}
	
	# Loop over individual side.
	foreach itrSide [set SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		# Set file name
		set fileName  /MIDAS/SpecData/R3B/TestData/
		append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
		append fileName "TuneFdbCurr-"
		append fileName "Side$itrSide-Asic$itrAsic.txt"
		
		# Create file and set permissions.
		set flagOpen [catch {open $fileName w} fileInput]
		set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
		if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
		if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
		
		# Enable test pulse injection
		set_asicValidate $itrSide $itrAsic 1
		# Set pulse params
		set pulseNumber 1024 ;# [a.u.]
		set pulseWidth  1000 ;# [10ns]
		set pulseDelay  19000;# [10ns]
		do_loadPulseParams $pulseWidth $pulseDelay $pulseNumber
		
		# Set pulse amplitude.
		set vcall 64  ;#[DN]
		set vcalh 155 ;#[DN]
		set registerVcall 17
		set registerVcalh 16
		WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcall] $vcall
		WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcalh] $vcalh
		
		set skipOffset 56
		variable offsetMin
		variable offsetMax
		if {$itrSide==0} {
		    set offsetMin  0;
		    set offsetMax  [expr 127-$skipOffset];
		} elseif {$itrSide==1} {
		    set offsetMin  128;
		    set offsetMax   [expr 255-$skipOffset];
		}
		
		set itrOffsetStep 12
		for {set itrOffset $offsetMin} {$itrOffset < [expr $offsetMax+1]} {set itrOffset [expr $itrOffset+$itrOffsetStep]} {
		    set channelNumber 128
		    for {set itrChannel 0} {$itrChannel < $channelNumber} {incr itrChannel} {
		     	set page 1
		     	WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + ($page << 8) + (128+$itrChannel) ] $itrOffset
		    }
		    after 10000 ;# [ms]
		    
		    # inject pulses, retrieve spectrum and dump data.
		    do_pulseInjection $pulseWidth $pulseDelay $pulseNumber $itrSide $itrAsic $itrOffset $fileInput 
		    
		} ;# end loop itrOffset
		
		close $fileInput
		# Disable test pulse injection
		set_asicValidate $itrSide $itrAsic 0 
		
	    } ;# end of loop over asic.
	} ;#end of loop over side.
	
	# Stop DAQ
	do_getState
	after 500 set timeout 1
	do_stop
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 0 } {return "Daq did not stop correctly";}
	
	return "Test completed"
	
    }
    
    proc do_pulseInjection { pulseWidth pulseDelay pulseNumber side asic offset fileInput } {
	
	# Loop over individual channels.
	set channelNumber 128
	set channelGroup 8
	for {set itrGroup 0} {$itrGroup < $channelNumber/$channelGroup} {incr itrGroup} {
	    
	    # To run on subset of channel.
	    # if {$itrGroup !=3 } { continue;}
	    
	    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
		set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
		set valuePwr [expr 255 - int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
		set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $registerPwr] $valuePwr
	    }
	    
	    # Inject pulses 
	    do_testPulse $pulseWidth $pulseDelay $pulseNumber
	    
	    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
		set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
		set fileName "E.$side.$asic.$dummyChannel"
		# Empty the content of the histogram 
		# Check also that the histogram has been created.
		if { [ZeroSpectrum $fileName] != 0 } { 
		    return "Histograms E.$side.$asic.* were not created";}
	    }
	    do_testPulse $pulseWidth $pulseDelay $pulseNumber
	    
	    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
		set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
		set plot  [do_analyseSpectra $side $asic $dummyChannel]
		set range [lindex $plot 0]
		set data  [lindex $plot 1]
		puts $fileInput "$side $asic $dummyChannel $offset $range"
		puts $fileInput $data
		flush $fileInput
	    }
	    
	    # Power off channel.
	    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
		set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
		set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $registerPwr] 255
	    }
	} ;# end of loop over channel.
	
    }
    
    proc do_loadOffsetEnTh { params } {
    	variable msgIden
	
	# --
	# TO BE RESTORED.
	# set name [lindex [lindex $params 1] 0]
	# set fileName [lindex [lindex $params 1] 1]
	# --
	
	#-- 
	# TO BE REMOVED.
	set fileName $params
	# --
	
	# Open file.
	set f [open $fileName]
	
	# Get header.
	variable side
	variable asic
	if {[gets $f  line] >= 0} {
	    set side    [lindex $line 0] ;
	    set asic    [lindex $line 1] ;
	}
	
	# Get body.
	while {[gets $f  line] >= 0} {
	    set channel [lindex $line 0]
	    set offset  [lindex $line 1]
	    
	    if {$offset >= 0} {
		set page 3
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$channel) ] $offset  
	    } elseif {$offset < 0} {
		set page 3
	 	WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$channel) ] [expr abs($offset) + 127];
	    }
	    
	}
	
	return $fileName
    }   
    
    proc do_loadFdbCurrOffset { params } {
	variable msgIden
	
	set name [lindex [lindex $params 1] 0]
	set fileName [lindex [lindex $params 1] 1]
	
	return $fileName
    }
    
    
    proc do_setPg1Offset { params } {
    	
	# set name [lindex [lindex $params 1] 0]
	set side [lindex [lindex $params 1] 1]	
	set asic [lindex [lindex $params 1] 2]
	set offset [lindex [lindex $params 1] 3]
	set page 1
	
	for {set itrChannel 0} {$itrChannel < 128} {incr itrChannel} {
	    
	    if {$offset >= 0} {
		
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] $offset  
	    } elseif {$offset < 0} {
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] [expr abs($offset) + 127];
	    }
	    
	}
	
	return "Side$side Asic$asic Page$page offsets set to $offset";
    }
    
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	# InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    INITIALIZE_ASICS {  InsertLog "[do_powerOffFrontEnd]"; InsertLog "[do_enableCalibration]"}
		    INITIALIZE_DAQ   { InsertLog "[do_initializeDaq $cgidata]" }
		    RESET            { set started 0; }
		    TUNE_FDBCURR     { InsertLog "[do_tuneFdbCurr $cgidata]" }
		    TUNE_FDBCURR_BIS { InsertLog "[do_tuneFdbCurrBis $cgidata]" }
		    LOAD_OFFSET_ENTH { InsertLog "[do_loadOffsetEnTh $cgidata]" }
		    SET_PG1_OFFSET   { InsertLog "[do_setPg1Offset $cgidata]";}
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}

