
#    Note:  This is loaded into the namespace  ASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    variable NREGS 22

    for {set i 0} {$i <= 22} {incr i} {variable OptC00.$i; set OptC00.$i 0}


   proc  show_variables {} {
       variable allmodules
       variable NREGS

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules"

       for {set i 0} {$i <= $NREGS} {incr i} {variable OptC00.$i; InsertLog "C00.$i = [set OptC00.$i]"}
   }

   proc do_redisplay {} {
     variable NREGS

     for {set i 0} {$i <= $NREGS} {incr i} {
        variable OptC00.$i
        set OptC00.$i [ReadR3BRegister [expr 0x300 + $i]]
     }
   }

   proc do_setOptC00 {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K
          WriteR3BRegister 0x300 0
          WriteR3BRegister [expr 0x300 + $i] $vl

          if {$i == 1 || $i == 2 || $i == 3 || $i == 4} {
              WriteR3BRegister 0x300 0x14   ;#  reset to load values
              WriteR3BRegister 0x300 0
          }
          
      }

      selectmodule $BAK   ;#  restore
   }
   
   proc set_ASICValidate {n} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC
       variable allmodules
   
#    bits VM0 and VM1 of ASIC REG1    n = 1 (enable for calibrate);   n = 3 (disable)

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          foreach SIDE [set SIDEList] {
             foreach ASIC [set ASICList$SIDE] {

                set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1]]     ;#  REG1
                set vl [expr ($vl & 0xc0) + ($n << 4)] 
                WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1] $vl
             }
          }
      }

      selectmodule $BAK   ;#  restore

   }

   proc do_ValPulse {n} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          do_setup                ;#  set default settings if needed

          if {$n == 99998} {     ;# stop continous mode
             WriteR3BRegister 0x300 0    ;#   stop
             set_ASICValidate 3
             continue
          }

          if {$n == 99999} {     ;# start continous mode 
             set_ASICValidate 1
             WriteR3BRegister 0x300 1   ;# start continous mode
             continue
          }

          WriteR3BRegister 0x300 0

          WriteR3BRegister 0x303 $n  ;# number of pulses

          WriteR3BRegister 0x300 4   ;#  reset to load values
          WriteR3BRegister 0x300 0

          set_ASICValidate 1
          WriteR3BRegister 0x300 3   ;#  start

      }

      selectmodule $BAK   ;#  restore

   }

   proc do_ResetPulse {n} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          do_setup                ;#  set default settings if needed

          WriteR3BRegister 0x300 8
          WriteR3BRegister 0x303 0

          InsertLog "generated ASIC reset for module $R3B4K"
          InsertLog "NOTE:  it is essential that a readout calibration is now performed - use SETUP"

      }

      selectmodule $BAK   ;#  restore

   }

   proc do_setup {} {
      variable allmodules
      global Options

   if {![info exists Options(R3B_ValPulseWidth)]} {set Options(R3B_ValPulseWidth) 800}
   if {![info exists Options(R3B_ValPulseDelay)]} {set Options(R3B_ValPulseDelay) 19200}
   if {![info exists Options(R3B_ResetPulseWidth)]} {set Options(R3B_ResetPulseWidth) 2000}

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

#    reg #1   val pulse width
#    reg #2   val pulse delay
#    reg #3   number
#    reg #4   reset pulse width

          foreach i {1 2 3 4} {
              set vl [ReadR3BRegister [expr 0x300 + $i]]
              if {$vl == 0} {
                  switch $i {
                      1  {set r $Options(R3B_ValPulseWidth)}
                      2  {set r $Options(R3B_ValPulseDelay)}
                      3  {set r 1}
                      4  {set r $Options(R3B_ResetPulseWidth)}
                  }
                  WriteR3BRegister [expr 0x300 + $i] $r
                  WriteR3BRegister 0x300 0x14   ;#  reset to load values
                  WriteR3BRegister 0x300 0
              }
          }
          do_redisplay
      }

      selectmodule $BAK   ;#  restore
   }

   proc do_expert {cmd} {

       switch $cmd {
          GenValPulse        {WriteR3BRegister 0x300 1; WriteR3BRegister 0x300 0;}
          GenASICResetPulse  {WriteR3BRegister 0x300 8; WriteR3BRegister 0x300 0;}
          ResetCounter       {WriteR3BRegister 0x300 0x20; WriteR3BRegister 0x300 0;}
          default {}
       }
   }
 
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
       	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		set vl [second [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    RESET    {set started 0}
		    CLEAR    {EmptyLog}
		    ELOG     {PrintLog}
		    RELOAD   {}
		    VARIABLES {show_variables}
		    
		    HIDE     {set ShowLogFlag 0}
		    SHOW     {set ShowLogFlag 1}
		    LOGON    {set LogFlag 1}
		    LOGOFF   {set LogFlag 0}
		    
		    MODULE     {selectmodule $vl}
		    ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
		    
		    OPTSC00  {do_setOptC00 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
		    EXPERT   {do_expert $vl}
		    
		    VALPULSE {do_ValPulse $vl}
                    RESETPULSE {do_ResetPulse $vl}
		    
                    MainLog {}
		    undefined {}
		    default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }
     do_redisplay

}   ;# end of if {$started == 0}




