
#    Note:  This is loaded into the namespace  Check

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable SYNC_Base_Collected 0

    variable allmodules 0
     

    for {set i 0} {$i <= 11} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules"

   }
  proc do_clock_check {} {

      set BAK $::R3B::R3B4K   ;#   save
	set passed 0
	set failed 0
	set Xpassed 0
	set Xfailed 0
      foreach R3B4K $::R3B::ModuleMenu {
	        set ::R3B::R3B4K $R3B4K
		set Test1 [expr 0x10 & [ ReadR3BRegister 0x400 + 1] ]
		if { $Test1 == 0x10 } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "R3B4K module $R3B4K global clocks not locked, $Test1 "
		}
		set Test1 [expr 2 & [ ReadR3BRegister 0x400] ]
		if { $Test1 == 2 } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "R3B4K module $R3B4K global clocks not External, $Test1 "
		}
	}
	InsertLog "Clock Lock test result: Passed $passed, Failed $failed"
	InsertLog "External clock test result: Passed $Mpassed, Failed $Mfailed"

      set ::R3B::R3B4K $BAK   ;#   restore
   }

  proc do_cal_check {} {
      set BAK $::R3B::R3B4K   ;#   save
	set passed 0
	set failed 0
      foreach R3B4K $::R3B::ModuleMenu {
	          set ::R3B::R3B4K $R3B4K
		 set Test1 [ ReadR3BRegister 0x802 ]
		 set Test2 [ ReadR3BRegister 0x803 ]
		 set Test3 [ ReadR3BRegister 0x804 ]
		if { $Test1 == 0xff && $Test2 == 0xf7 && $Test3 == 0xff } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "R3B4K module $R3B4K failed"
		}
      }
	InsertLog "Calibration test result: Passed $passed, Failed $failed"
      set ::R3B::R3B4K $BAK   ;#   restore
   }
   
   proc do_version_check {} {
	set BAK $::R3B::R3B4K   ;#   save
	set date 0
	set version 0
	set passed 1
	set failed 0
    foreach R3B4K $::R3B::ModuleMenu {
	    set ::R3B::R3B4K $R3B4K
		set Test1 [ ReadR3BRegister 0 ] ;# Date Register
		set Test2 [ ReadR3BRegister 0x1 ] ;# Version Register
		if { $date == 0 } {
			set date $Test1 
			set version $Test2
		} else {
			if { $Test1 == $date && $Test2 == $version } {
				set passed [ expr $passed + 1 ]
			} else {
				set failed [ expr $failed + 1 ]
				InsertLog "R3B4K module $R3B4K Different. Date = $Test1 and Version= $Test2"
			}
		}
    }
	InsertLog "VHDL Version Check test result: Passed $passed, Failed $failed"
    set ::R3B::R3B4K $BAK   ;#   restore
  
   }


   proc do_redisplay {} {
}

 
   proc Show_SYNCRX_Counters {} {
    set BAK $::R3B::R3B4K   ;#   save

      foreach R3B4K $::R3B::ModuleMenu {
	  	set ::R3B::R3B4K $R3B4K
		set val$R3B4K [ ReadR3BRegister [ expr 0x400 + 7] ]
	}
     foreach R3B4K $::R3B::ModuleMenu {
		InsertLog "$R3B4K => [format "%d" [ set val$R3B4K ] ]"
	}
      set ::R3B::R3B4K $BAK   ;#   restore
}
 
   proc Show_SYNC_Counters {} {
    set BAK $::R3B::R3B4K   ;#   save

      foreach R3B4K $::R3B::ModuleMenu {
	  	set ::R3B::R3B4K $R3B4K
		set val [ ReadR3BRegister [ expr 0x400 + 14] ]
		InsertLog "$R3B4K => [format "%d" $val ]"
	}
      set ::R3B::R3B4K $BAK   ;#   restore
}

   proc Collect_SYNC_Base {} {
     variable SYNC_Base_Collected
     set BAK $::R3B::R3B4K   ;#   save

      foreach R3B4K $::R3B::ModuleMenu {
	  	set ::R3B::R3B4K $R3B4K
		variable Sync_Base_$R3B4K
		set Sync_Base_$R3B4K [ ReadR3BRegister [ expr 0x400 + 14] ]
	}
      set SYNC_Base_Collected 1
      set ::R3B::R3B4K $BAK   ;#   restore
}


   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#   save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K

      }

      set ::R3B::R3B4K $BAK   ;#   restore
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

		VERSION_CHECK {do_version_check}
		CAL_CHECK	{do_cal_check}
		CLOCK_CHECK { do_clock_check }


                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




