
#    Note:  This is loaded into the namespace  COMMS

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define COMMS variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""


   proc  show_variables {} {

   }

   proc do_redisplay {} {

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] == "Query"} then {do_query; return}
           if {[lindex $cgidata 0] == "Action"} then {do_action; return}
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}



   proc do_action {} {
      variable cgidata
      global Httpd
      upvar #0 Httpd[set Httpd(currentSocket)] data

     set sock $Httpd(currentSocket)

     set m ""

     append m "do_action\n"
     append m "uri = $data(uri)\n"

     set info [second [split $data(uri) ?]]

     if {[string compare -length 7 "Action=" "$info"] == 0} {

         set action [string range $info 7 end]
         append m "action = $action\n"

         set params [split $action :]

         set Cmd [first $params]
         set Modid [second [split [third $params] =]]

         append m "Cmd = $Cmd\n"

         switch [first $params] {

            PowerOff {

              InsertLog "action complete"
 
            }

            undefined -
            default {append m "unexpected action: $action\n"}
         }
     }

      append m "*****action request done*****\n"

      Httpd_ReturnData $sock "http" $m 

   }

   proc do_query {} {
      global Httpd
      upvar #0 Httpd[set Httpd(currentSocket)] data

     set sock $Httpd(currentSocket)

     set m ""

     append m "do_query\n"
     append m "uri = $data(uri)\n"

     set info [second [split $data(uri) ?]]

     if {[string compare -length 6 "Query=" "$info"] == 0} {

         set query [string range $info 6 end]
         append m "query = $query\n"

         set qlist [split $query &]

         foreach q $qlist {

            switch $q {

              undefined -
              default {append m "unexpected query: $q\n"}
            }
         }
      }

      append m "*****query request done*****\n"

      Httpd_ReturnData $sock "http" $m 

   }




