# Note:  This is loaded into the namespace MTEST02V1
# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {
    
    variable JS ""
    variable LogFlag
    
    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}
    
    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    # --
    # TO BE REMOVED
    proc do_setPg1Offset { itrSide itrAsic itrOffset } {
    	
	# set name [lindex [lindex $params 1] 0]
	set side   $itrSide;#[lindex [lindex $params 1] 1]	
	set asic   $itrAsic;#[lindex [lindex $params 1] 2]
	set offset $itrOffset;#[lindex [lindex $params 1] 3]
	set page 1
	
	for {set itrChannel 0} {$itrChannel < 128} {incr itrChannel} {
	    
	    if {$offset >= 0} {
		
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] $offset  
	    } elseif {$offset < 0} {
		WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + ($page << 8) + (128+$itrChannel) ] [expr abs($offset) + 127];
	    }
	    
	}
	
	return "Side$side Asic$asic Page$page offsets set to $offset";
    }
    #--
    
    proc do_test02V1 { params } {
       global SIDEList
       global ASICList0 ASICLIST1
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	set stepVcal    1; #[lindex [lindex $params 1] 3] ;# [DN]
	set vcall       64;   # [DN] Set vcall to 0.5V.
	set vcalh       160;  # [DN] Set vcalh to 0.75V.
	set pulseWidth  1000; # [10ns] 
	set pulseDelay  19000;# [10ns]
	set pulseNumber 512;  # [a.u.]
	
	do_getState 
	# Start DAQ.
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 1 } {return "Daq not started properly.";}
	
	# Loop over individual side.
	foreach itrSide [set SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		# --
		# TO BE REMOVED.
		# Loop over PkTm and load offsets.
		foreach itrPg1 {-50 -100} {
		    foreach itrPkTm {14 126 254} {
			# --
			
			# # --
			# # TO BE RESTORED
			# # Set file name
			# set fileName  /MIDAS/SpecData/R3B/TestData/
			# append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
			# append fileName "Test02V1-"
			# append fileName "Side$itrSide-Asic$itrAsic.txt"
			# # --
			
			# --
			# TO BE REMOVED.
			# Set PkTm.
			set registerPkTm 4
			WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPkTm] $itrPkTm 
			# Set file name
			set fileName  /MIDAS/SpecData/R3B/TestData/
			append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
			append fileName "Test02V1-"
			append fileName "Side$itrSide-Asic$itrAsic-Reg4-$itrPkTm-Pg1-$itrPg1.txt"
			InsertLog "[do_setPg1Offset $itrSide $itrAsic $itrPg1]"
			# --
			
			# Create file and set permissions.
			set flagOpen [catch {open $fileName w} fileInput]
			set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
			if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
			if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
			
			# Flush file header.
			puts $fileInput "$itrSide $itrAsic $vcall $vcalh $stepVcal"
			flush $fileInput
			
			# Enable test pulse injection
			set_asicValidate $itrSide $itrAsic 1
			# Set pulse params
			do_loadPulseParams $pulseWidth $pulseDelay $pulseNumber
			
			# Set vcall.
			set registerVcall 17
			WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcall] $vcall 
			
			# Set vcalh: min and max.
			set minVcalh [expr $vcall + $stepVcal]; # [DN]
			set maxVcalh $vcalh;# [DN]
			set registerVcalh 16
			
			# Loop over individual channels.
			set channelNumber 128
			set channelGroup 8
			for {set itrGroup 0} {$itrGroup < $channelNumber/$channelGroup} {incr itrGroup} {
			    
			    # To run on subset of channel.
			    # if {$itrGroup !=0} { continue;}
			    
			    # Power on channels.
			    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				set valuePwr [expr 255 - int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
				set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
			    }
			    
			    # Make loop on pulse amplitude.
			    for {set itrVcalh $minVcalh} {$itrVcalh <= $maxVcalh} {set itrVcalh [expr $itrVcalh + $stepVcal]} {
				# if {$itrVcalh!=65} {continue;}
				
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcalh] $itrVcalh
				# Inject pulses 
				do_testPulse $pulseWidth $pulseDelay $pulseNumber
				
				for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				    set fileName "E.$itrSide.$itrAsic.$dummyChannel"
				    # Empty the content of the histogram 
				    # Check also that the histogram has been created.
				    if { [ZeroSpectrum $fileName] != 0 } { 
					return "Histograms E.$itrSide.$itrAsic.* were not created";}
				}
				do_testPulse $pulseWidth $pulseDelay $pulseNumber
				
				for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				    set plot  [do_analyseSpectra $itrSide $itrAsic $dummyChannel]
				    set range [lindex $plot 0]
				    set data  [lindex $plot 1]
				    set deltaVcal [expr $itrVcalh - $vcall]
				    puts $fileInput "$dummyChannel $deltaVcal $range"
				    puts $fileInput $data
				    flush $fileInput
				}
				
			    } ;# end of loop over pulse amplitude.
			    
			    # Power off channel.
			    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
				WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
			    }
			    
			} ;# end of loop over channel. 
			
			close $fileInput
			# Disable test pulse injection
			set_asicValidate $itrSide $itrAsic 0 
			
			# --
			# TO BE REMOVED.
		    } ;# end of foreach itrPg1
		} ;# end of foreach itrPkTm
		#--
		
	    } ;# end of loop over asic.
	} ;# end of loop over side.
	
	# Stop DAQ
	do_getState
	after 500 set timeout 1
	do_stop
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 0 } {return "Daq did not stop correctly";}
	
	InsertLog "Test completed"
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}

	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    INITIALIZE_ASICS {InsertLog "[do_powerOffFrontEnd]"; InsertLog "[do_enableCalibration]"}
		    INITIALIZE_DAQ {InsertLog "[do_initializeDaq $cgidata]"}
		    RESET    {set started 0}
		    TEST02V1 {InsertLog "[do_test02V1 $cgidata]"}
		    
		    MainLog {}
		    undefined {}
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
        do_redisplay
    }
    
}   ;# end of if {$started == 0}
