
#    Note:  This is loaded into the namespace  LVHVPOWER

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click;   after 5000 ::LVHVPOWER::doSTATUS
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable Interlock 7
    variable NumDet 7
    variable Detector 1

    for {set i 0} {$i < $NumDet} {incr i} {variable Status$i "unknown"}
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i "No"}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i "No"}
    for {set i 0} {$i < $NumDet} {incr i} {variable HV$i "No"}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i "Yes"}

    variable debugenable 0
    variable debugopt ""

    variable stateicon "yellow.png"

    variable config_file "/MIDAS/R3B/data/config.dat"
    variable help_file "/MIDAS/R3B/data/help.txt"
    variable req_file "/MIDAS/R3B/data/request.dat"
    variable req_pgm "/usr/local/bin/r3b_power_v2"
    variable stat_file "/MIDAS/R3B/data/status.dat"
    variable stat_pgm  "/usr/local/bin/r3b_status_v2"
    variable alrm_pgm  "/usr/local/bin/r3b_alarm"
    variable emerg_pgm "/MIDAS/R3B/pt100/r3b_power/r3b_power"


   proc  show_variables {} {
     variable stat_file
      variable stat_pgm

      set z [catch {file delete -force $stat_file} m]
      if {$z != 0} {InsertLog "status file delete => $m"}

      set z [catch {exec $stat_pgm  -f $stat_file} m]

      if {$z != 0} {InsertLog "exec $stat_pgm  -f $stat_file  > $z $m"}

      if {$z == 0} {

         set z [catch {open $stat_file r} f]
         set r [read $f]
         close $f
         InsertLog "status >\n$r"
      }

   }

   proc doINUSE {vl} {

      variable Detector
      set Detector $vl

      variable InUse$Detector

      switch [set InUse$Detector] {
         "No"  {set InUse$Detector "Yes"}
         "Yes" {set InUse$Detector "No"}
      }
   
   }

   proc doLV {vl} {
   
      variable Detector
      set Detector $vl

      variable LV$Detector
      variable HV$Detector
      variable LVHV$Detector

      switch [set LV$Detector] {
         "No"  {set LV$Detector "Yes"; set HV$Detector "No"; set LVHV$Detector "No"}
         "Yes" {set LV$Detector "No"}
      }
   }

   proc doHV {vl} {
   
      variable Detector
      set Detector $vl

      variable LV$Detector
      variable HV$Detector
      variable LVHV$Detector

      switch [set HV$Detector] {
         "No"  {set HV$Detector "Yes"; set LV$Detector "No"; set LVHV$Detector "No"}
         "Yes" {set HV$Detector "No"}
      }
   }

   proc doLVHV {vl} {
   
      variable Detector
      set Detector $vl

      variable LV$Detector
      variable HV$Detector
      variable LVHV$Detector

      switch [set LVHV$Detector] {
         "No"  {set LVHV$Detector "Yes"; set LV$Detector "No"; set HV$Detector "No"}
         "Yes" {set LVHV$Detector "No"}
      }
   }


   proc doON {} {
      variable NumDet
      variable Detector
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i}

      variable req_file
      variable req_pgm
      variable debugenable

      global errorInfo errorCode

      set z [catch {open $req_file w} f]
      if {$z != 0} {InsertLog "power on fails => $f"; return}

      set dets 0
      for {set i 0} {$i < $NumDet} {incr i} {
        if {[set InUse$i] == "Yes"} {
           puts $f "$i on delay 1 1 1"
           incr dets
        }
      }

      close $f

      if {$dets == 0} {InsertLog "nothing to do"; return}

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $req_pgm  -f $req_file} m]
             } else {
                set rc [catch {exec $req_pgm -debug -f $req_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doON} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "HV PSU warning"}
            8   {set m "LV PSU warning"}
            16  {set m "PSU off delay warning"}
            32  {set m "PSU on delay warning"}
            64  {set m "HV voltage off warning"}
            128  {set m "LV voltage on warning"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "ON:  operation completed successfully"
      }

      InsertLog "$m"

   }

   proc doOFF {} {
      variable NumDet
      variable Detector
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i}

      variable req_file
      variable req_pgm
      variable debugenable

      global errorInfo errorCode

      set z [catch {open $req_file w} f]
      if {$z != 0} {InsertLog "power off fails => $f"; return}

      set dets 0
      for {set i 0} {$i < $NumDet} {incr i} {
        if {[set InUse$i] == "Yes"} {
           puts $f "$i off delay 1 1 1"
           incr dets
        }
      }

      close $f

      if {$dets == 0} {InsertLog "nothing to do"; return}

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $req_pgm  -f $req_file} m]
             } else {
                set rc [catch {exec $req_pgm -debug -f $req_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doOFF} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "LV PSU warning"}
            8   {set m "HV PSU warning"}
            16  {set m "error populating internal <Status Table>"}
            32  {set m "error attempting to write <Status File>"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
         return
      } else {
         set m "OFF: operation completed successfully"
      }

      InsertLog "$m"
   
   }

   proc doPON {vl} {       ;# switch on a single detector
      variable NumDet
      variable Detector
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable HV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i}

      variable req_file
      variable req_pgm
      variable debugenable

      global errorInfo errorCode

      set Detector $vl
      if {[set InUse$Detector] == "No"} {InsertLog "Detector $vl is not InUse"; return}
      
      set z [catch {open $req_file w} f]
      if {$z != 0} {InsertLog "power on fails => $f"; return}
      if {[set LV$Detector] == "Yes"}   {puts $f "$Detector on nodelay 1 1 0"}
      if {[set HV$Detector] == "Yes"}   {puts $f "$Detector on nodelay 0 0 1"}
      if {[set LVHV$Detector] == "Yes"} {puts $f "$Detector on delay 1 1 1"}
      close $f

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $req_pgm  -f $req_file} m]
             } else {
                set rc [catch {exec $req_pgm -debug -f $req_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doON} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "HV PSU warning"}
            8   {set m "LV PSU warning"}
            16  {set m "PSU off delay warning"}
            32  {set m "PSU on delay warning"}
            64  {set m "HV voltage off warning"}
            128  {set m "LV voltage on warning"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "ON:  operation completed successfully"
      }

      InsertLog "$m"

   }

   proc doPOFF {vl} {       ;# switch off a single detector
      variable NumDet
      variable Detector
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable HV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i}

      variable req_file
      variable req_pgm
      variable debugenable

      global errorInfo errorCode

      set Detector $vl
      if {[set InUse$Detector] == "No"} {InsertLog "Detector $vl is not InUse"; return}
      
      set z [catch {open $req_file w} f]
      if {$z != 0} {InsertLog "power on fails => $f"; return}
      if {[set LV$Detector] == "Yes"}   {puts $f "$Detector off nodelay 1 1 0"}
      if {[set HV$Detector] == "Yes"}   {puts $f "$Detector off nodelay 0 0 1"}
      if {[set LVHV$Detector] == "Yes"} {puts $f "$Detector off delay 1 1 1"}
      close $f

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $req_pgm  -f $req_file} m]
             } else {
                set rc [catch {exec $req_pgm -debug -f $req_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doOFF} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "LV PSU warning"}
            8   {set m "HV PSU warning"}
            16  {set m "error populating internal <Status Table>"}
            32  {set m "error attempting to write <Status File>"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
         return
      } else {
         set m "OFF: operation completed successfully"
      }

      InsertLog "$m"

   }

   proc doSTATUS {} {
      global errorCode
      variable stat_file
      variable stat_pgm
      variable Detector
      variable debugenable

      set z [catch {file delete -force $stat_file} m]
      if {$z != 0} {InsertLog "status fails => $m"; return}

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $stat_pgm  -f $stat_file} m]
             } else {
                set rc [catch {exec $stat_pgm -debug -f $stat_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doSTATUS} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "HV PSU warning"}
            8   {set m "LV PSU warning"}
            16  {set m "PSU off delay warning"}
            32  {set m "PSU on delay warning"}
            64  {set m "HV voltage off warning"}
            128  {set m "LV voltage on warning"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "STATUS: operation completed successfully"
      }
      InsertLog "$m"

      set z [catch {open $stat_file r} f]
      if {$z != 0} {InsertLog "status fails => $f"; return}
      set r [read $f]
      close $f

      foreach line [split $r \n] {
         set det [lindex $line 0]
         set status [lreplace $line 0 0]

         variable Status$det; set Status$det $status
      }
   }

   proc doEMERGENCY {} {
      global errorCode errorInfo
      variable emerg_pgm

      set rc [catch {exec $emerg_pgm  -off} m]
      InsertLog "exec $emerg_pgm -off"
      if {$rc == 0} {InsertLog "reply=$m"} else {InsertLog "reply=$errorCode"}

   }

   proc doInterlockON {} {doInterlock on}
   proc doInterlockOFF {} {doInterlock off}

   proc doInterlock {w} {
      variable Interlock

      variable req_file
      variable req_pgm
      variable debugenable

      global errorInfo errorCode

      set z [catch {open $req_file w} f]
      if {$z != 0} {InsertLog "power on fails => $f"; return}

      puts $f "$Interlock $w nodelay 1 1 0"

      close $f

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $req_pgm  -f $req_file} m]
             } else {
                set rc [catch {exec $req_pgm -debug -f $req_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doInterlock$w} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "HV PSU warning"}
            8   {set m "LV PSU warning"}
            16  {set m "PSU off delay warning"}
            32  {set m "PSU on delay warning"}
            64  {set m "HV voltage off warning"}
            128  {set m "LV voltage on warning"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "operation completed successfully"
      }

      InsertLog "$m"
   
   }

   proc doClrLValarm {} {InsertLog "doClrLValarm"

      variable alrm_pgm
      variable debugenable

      global errorInfo errorCode

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $alrm_pgm  -lv} m]
             } else {
                set rc [catch {exec $alrm_pgm -debug -lv} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doClrLValarm} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "arguments error"}
            3   {set m "LV PSU error"}
            4   {set m "HV PSU error"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "operation completed successfully"
      }

      InsertLog "$m"
   
   }

   proc doClrHValarm {} {InsertLog "doClrHValarm"

      variable alrm_pgm
      variable debugenable

      global errorInfo errorCode

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $alrm_pgm  -hv} m]
             } else {
                set rc [catch {exec $alrm_pgm -debug -hv} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doClrHValarm} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "arguments error"}
            3   {set m "LV PSU error"}
            4   {set m "HV PSU error"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "operation completed successfully"
      }

      InsertLog "$m"
   
   }

   proc doLVHVstatus {} {InsertLog "doLVHVstatus";
      global errorCode
      variable stat_file
      variable stat_pgm
      variable Detector
      variable debugenable

      set z [catch {file delete -force $stat_file} m]
      if {$z != 0} {InsertLog "status fails => $m"; return}

      switch [exec uname -p] {
          x86_64  {
             if {$debugenable == 0} {
                set rc [catch {exec $stat_pgm  -f $stat_file} m]
             } else {
                set rc [catch {exec $stat_pgm -debug -f $stat_file} m]
             }
          }
          ppc     {set rc [catch {curl --url http://myserver:8015/R3B/LVHVPower/POWER.tml?Action=doSTATUS} m]}
      }

      InsertLog "$m"

      if {$rc != 0} {
         switch [lindex $errorCode 2] {
            1   {set m "arguments error"}
            2   {set m "internal (software) error"}
            4   {set m "HV PSU warning"}
            8   {set m "LV PSU warning"}
            16  {set m "PSU off delay warning"}
            32  {set m "PSU on delay warning"}
            64  {set m "HV voltage off warning"}
            128  {set m "LV voltage on warning"}
            default {set m "unknown error [lindex $errorCode 2]"}
         }
      } else {
         set m "STATUS: operation completed successfully"
      }
      InsertLog "$m"

      set z [catch {open $stat_file r} f]
      if {$z != 0} {InsertLog "status fails => $f"; return}
      set r [read $f]
      close $f

      foreach line [split $r \n] {
         InsertLog "$line"
      }
   }



   proc doSAVE {} {
     variable config_file
     variable NumDet
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable HV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i}

      set z [catch {open $config_file w} f]
      if {$z != 0} {InsertLog "save fails => $f"; return}
      for {set i 0} {$i < $NumDet} {incr i} {
          puts $f "$i [set InUse$i] [set LV$i] [set HV$i] [set LVHV$i]"
      }
      close $f

      InsertLog "configuration saved to $config_file"

   }

   proc doRESTORE {} {
     variable config_file
     variable NumDet
    for {set i 0} {$i < $NumDet} {incr i} {variable InUse$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable HV$i}
    for {set i 0} {$i < $NumDet} {incr i} {variable LVHV$i}

      set z [catch {open $config_file r} f]
      if {$z != 0} {InsertLog "restore fails => $f"; return}
      for {set i 0} {$i < $NumDet} {incr i} {
          set config [gets $f]
          set j [lindex $config 0]
          set InUse$j [lindex $config 1]  
          set LV$j [lindex $config 2]
          set HV$j [lindex $config 3]
          set LVHV$j [lindex $config 4]
      }
      close $f

      InsertLog "configuration restored from $config_file"

   }

   proc doLVstatus  {} {doLVHVstatus}
   proc doHVstatus  {} {doLVHVstatus}

   proc do_expert {cmd} {

          switch $cmd {
              default {$cmd}
          }
   }

   proc do_HELP {} {
      variable help_file

      set z [catch {open $help_file r} f]
      if {$z != 0} {InsertLog "help fails => $f"; return}
      set helpdata [read $f]
      close $f

      InsertLog "$helpdata"

   }

   proc doDEBUG {} {
      variable debugenable
      variable debugopt

      set debugenable [expr ($debugenable + 1) & 1]
      if {$debugenable == 0} {set debugopt ""} else {set debugopt "-debug"}

   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] == "Query"} then {do_query; return}
           if {[lindex $cgidata 0] == "Action"} then {do_action; return}
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {doSTATUS}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ON        {doON}
                   OFF       {doOFF}
                   STATE     {doSTATUS}
                   EMERGENCY {doEMERGENCY}
                   DEBUG     {variable debugenable; set debugenable [expr ($debugenable + 1) & 1]}

                   INUSE     {doINUSE $vl}
                   LV        {doLV $vl}
                   HV        {doHV $vl}
                   LVHV      {doLVHV $vl}
                   PON       {doPON $vl}
                   POFF      {doPOFF $vl}

                   EXPERT   {do_expert $vl}
                   HELP     {do_HELP; return}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

   }   ;#  end of do_click

     doRESTORE
     doSTATUS

}   ;# end of if {$started == 0}



   proc do_action {} {
      variable cgidata
      global Httpd
      upvar #0 Httpd[set Httpd(currentSocket)] data

     set sock $Httpd(currentSocket)

     set m ""

     append m "do_action\n"
     append m "uri = $data(uri)\n"

     set info [second [split $data(uri) ?]]

     if {[string compare -length 7 "Action=" "$info"] == 0} {

         set action [string range $info 7 end]
         append m "action = $action\n"

         set params [split $action :]

         set Cmd [first $params]
         set Modid [second [split [third $params] =]]

         append m "Cmd = $Cmd\n"
         append m "Modid = $Modid\n"

         switch [first $params] {

            doSTATUS {doSTATUS}
            doPOWER {
               set rc [catch {exec /MIDAS/R3B/pt100/ChOff/r3b_ch_off -id $Modid} r]
               append m "exec /MIDAS/R3B/pt100/ChOff/r3b_ch_off -id $Modid\n"
               append m "rc=$rc; reply=$r\n"
            }

            undefined -
            default {append m "unexpected action: $action\n"}
         }
     }

      append m "*****action request done*****\n"

      Httpd_ReturnData $sock "http" $m 

   }

   proc do_query {} {
      global Httpd
      upvar #0 Httpd[set Httpd(currentSocket)] data

     set sock $Httpd(currentSocket)

     set m ""

     append m "do_query\n"
     append m "uri = $data(uri)\n"

     set info [second [split $data(uri) ?]]

     if {[string compare -length 6 "Query=" "$info"] == 0} {

         set query [string range $info 6 end]
         append m "query = $query\n"

         set qlist [split $query &]

         foreach q $qlist {

            switch $q {

              undefined -
              default {append m "unexpected query: $q\n"}
            }
         }
      }

      append m "*****query request done*****\n"

      Httpd_ReturnData $sock "http" $m 

   }



