
#    Note:  This is loaded into the namespace  R3B_SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable DBNameList {"xxx"}

   variable index 0
   variable selected -1
   variable asicselected0 0x0
   variable asicselected1 0x0

    global NumASICSperSIDE
    global SIDEList
    foreach side $SIDEList {
        switch $NumASICSperSIDE {
           16   {set asicsselected$side 0xffff}
           12   {set asicselected$side 0x0fff}
            6   {set asicselected$side 0x003f}
        }
    }

   proc show_variables {} {
      global env
      global NumSide
      global ModID0 ModID1
      global NumASICSperSIDE
      global SIDEList
      global ASICList0 ASICList1
      global SIDE
      global ASIC
      variable selected

      set BAK $::R3B::R3B4K  ;# save	

      set i 0
      foreach R3B4K $::R3B::ModuleMenu {
	  incr i
	  if {[expr ($selected >> $i) & 1] == 0} {continue}

          selectmodule $R3B4K

          InsertLog "module = $::R3B::R3B4K"

          InsertLog "NumSide = $NumSide"
          InsertLog "NumASICSperSIDE = $NumASICSperSIDE"
          InsertLog "SIDEs = $SIDEList"
          InsertLog "ASICs 0 = $ASICList0"
          InsertLog "ASICs 1 = $ASICList1"

          InsertLog "SIDE = $SIDE; ASIC = $ASIC"
          InsertLog "ModID 0 = $ModID0;  ModID 1 = $ModID1"
      }

      selectmodule $BAK

        InsertLog "DB Root = [file join $env(MIDASBASE) DB]"
        InsertLog "DBPath = $::R3B::DBRootName/$::R3B::DBNodeBase/"
        InsertLog "DB Node Name = $::R3B::DBNodeName"

#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"

   }

      proc Selection {} {
          variable selected

          set selected 0

           set i 1
           foreach item $::R3B::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }

      proc do_SelectASIC0 {i} {
         variable asicselected0
         global NumASICSperSIDE
         set num [expr $NumASICSperSIDE - 1]
         
         if {$i < 0} {
             set asicselected0 0x0
             set side 0
             switch $NumASICSperSIDE {
               16   {set asicselected$side 0xffff}
               12   {set asicselected$side 0x0fff}
                6   {set asicselected$side 0x003f}
             }
             return
         }

         set asicselected0 [expr $asicselected0 | (1 << [expr $num-$i])]
      }

      proc do_SelectASIC1 {i} {
         variable asicselected1
         global NumASICSperSIDE
         set num [expr $NumASICSperSIDE - 1]

         if {$i < 0} {
             set asicselected1 0x0
             set side 1
             switch $NumASICSperSIDE {
               16   {set asicselected$side 0xffff}
               12   {set asicselected$side 0x0fff}
                6   {set asicselected$side 0x003f}
             }
             return
         }

         set asicselected1 [expr $asicselected1 | (1 << [expr $num-$i])]
      }

      proc do_UnSelectASIC0 {i} {
         variable asicselected0
           global NumASICSperSIDE
           set num [expr $NumASICSperSIDE - 1]
         
         if {$i < 0} {set asicselected0 0; return}

         set asicselected0 [expr $asicselected0 & ~(1 << [expr $num-$i])]
      }

      proc do_UnSelectASIC1 {i} {
         variable asicselected1
           global NumASICSperSIDE
           set num [expr $NumASICSperSIDE - 1]
         
         if {$i < 0} {set asicselected1 0; return}

         set asicselected1 [expr $asicselected1 & ~(1 << [expr $num-$i])]
      }

      proc do_Save {} {
        variable SpecBase
	  variable selected
	  variable asicselected0
	  variable asicselected1
	  
	  if {$selected == 0} {Selection}

        InsertLog "[date +%Y%h%d-%H.%M.%S] Saving R3B4K settings to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
	  set BAK $::R3B::R3B4K   ;# save
	  
	  set i 0
	  foreach R3B4K $::R3B::ModuleMenu {
	      incr i
	      if {[expr ($selected >> $i) & 1] == 0} {continue}
	      
	      set ::DataAcquisition::ACQSERVER $R3B4K
	      DAQ_DoOption "ParameterSave=$::R3B::DBNodeBase [expr $asicselected1 << 16 | $asicselected0]"
	      
	      InsertLog "R3B4K settings saved for $R3B4K with selector [format 0x%08x [expr $asicselected1 << 16 | $asicselected0]] "
	  }
	  
	  set ::R3B::R3B4K $BAK    ;# restore

        InsertLog "[date +%Y%h%d-%H.%M.%S] R3B4K settings saved to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
	  #        Elog INFORMATION "R3B4K histograms saved to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
          do_DBUpdate
      }
    
      proc do_Restore {} {
        variable SpecBase
	  variable selected
	  variable asicselected0
	  variable asicselected1
	  
	  if {$selected == 0} {Selection}

        InsertLog "[date +%Y%h%d-%H.%M.%S] Saving R3B4K settings to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
	  set BAK $::R3B::R3B4K   ;# save
	  
	  set i 0
	  foreach R3B4K $::R3B::ModuleMenu {
	      incr i
	      if {[expr ($selected >> $i) & 1] == 0} {continue}
	      
	      set ::DataAcquisition::ACQSERVER $R3B4K
	      DAQ_DoOption "ParameterRestore=$::R3B::DBNodeBase [expr $asicselected1 << 16 | $asicselected0]"
	      
	      InsertLog "R3B4K settings restore for $R3B4K with selector [format 0x%08x [expr $asicselected1 << 16 | $asicselected0]] "
	  }
	  
	  set ::R3B::R3B4K $BAK    ;# restore

        InsertLog "[date +%Y%h%d-%H.%M.%S] R3B4K settings restore to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
	  #        Elog INFORMATION "R3B4K histograms saved to $::R3B::DBRootName/$::R3B::DBNodeBase"
	  
          do_DBUpdate
      }

      proc do_DBName {vl} {
         global env
         global Options

          set ::R3B::DBNodeBase $vl
          DBCreateNode [file join $::R3B::DBRootName $::R3B::DBNodeBase]

     set z1 [catch {file attributes [file join $env(MIDASBASE) DB $::R3B::DBRootName] -permissions rwxrwxrwx} m1]
     if {$z1 != 0} {InsertLog "creating DB structure: $z1 $m1"}

     set z2 [catch {file attributes [file join $env(MIDASBASE) DB $::R3B::DBRootName $::R3B::DBNodeBase] -permissions rwxrwxrwx} m2]
     if {$z2 != 0} {InsertLog "creating DB structure: $z2 $m2"}

          set Options(ASIC.settings) $vl
          SaveOptions

          InsertLog "Data Base node [file join $::R3B::DBRootName/$::R3B::DBNodeBase] contains \
               [DBGetNodes [file join $::R3B::DBRootName $::R3B::DBNodeBase] *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::R3B::DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE  {do_Restore}
                SAVE     {do_Save}

                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}
                SELECTASIC    {do_SelectASIC0 [lindex $w 1]; do_SelectASIC1 [lindex $w 1]}
                UNSELECTASIC  {do_UnSelectASIC0 [lindex $w 1]; do_UnSelectASIC1 [lindex $w 1]}
                SELECTASIC0    {do_SelectASIC0 [lindex $w 1]}
                UNSELECTASIC0  {do_UnSelectASIC0 [lindex $w 1]}
                SELECTASIC1    {do_SelectASIC1 [lindex $w 1]}
                UNSELECTASIC1  {do_UnSelectASIC1 [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

     Selection

     do_DBUpdate
     LoadOptions

     set html ""


}  ;# end of if {$started == 0}

