
#    Note:  This is loaded into the namespace  TIMES

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable INFO ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable INFO ""

    variable allmodules 0

    for {set i 0} {$i <= 1} {incr i} {variable Opt1000.$i 0}

#   proc selectmodule {vl} {set ::R3B::R3B4K $vl}

   proc  show_variables {} {
       variable allmodules 

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules"

       for {set i 0} {$i <= 0} {incr i} {variable Opt1000.$i; InsertLog "1000.$i = [set Opt1000.$i]"}
   }

   proc do_redisplay {} {

     for {set i 0} {$i <= 1} {incr i} {
        variable Opt1000.$i
        set Opt1000.$i [ReadR3BRegister [expr 0x400 + $i]]
     }

     if {[expr [set Opt1000.1] & 48] == 0} {InsertLog "WARNING: DCM not locked - status = [set Opt1000.1]"}
   }

   proc do_setOpt1000 {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K
          WriteR3BRegister [expr 0x400 + $i] $vl
      }

      selectmodule $BAK  ;#  restore
   }

   proc do_expert {cmd} {

       switch $cmd {

          ResetTimeStamp {do_ResetTimeStamp}
          SetExternalClock {do_SetExternalClock}
          SetInternalClock {do_SetInternalClock}
          default {}
       }
   }

   proc do_ResetTimeStamp {} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC

      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          set SBAK $SIDE
          foreach SIDE $SIDEList {

          set ABAK $ASIC
          foreach ASIC [set ASICList$SIDE] {

              set i 1    ;#  REG1
              set REG1.$SIDE.$ASIC [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
              set vl [expr ([set REG1.$SIDE.$ASIC] & 0xc0) + 0x20]  ;# VAL input resets the counter
              WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl

          }
          set ASIC $ABAK
          }
          set SIDE $SBAK

          WriteR3BRegister 0x400 3   ;#  asic_val => ts_fpga_reset

          WriteR3BRegister 0x300 0

          set reg1 [ReadR3BRegister 0x301]
          WriteR3BRegister 0x301 10
          set reg2 [ReadR3BRegister 0x302]
          WriteR3BRegister 0x302 1
          set reg3 [ReadR3BRegister 0x303]
          WriteR3BRegister 0x303 1  ;# number of pulses

          WriteR3BRegister 0x300 4   ;#  reset to load values
          WriteR3BRegister 0x300 0

          WriteR3BRegister 0x300 3   ;#  start

          WriteR3BRegister 0x300 0   ;#  stop

          WriteR3BRegister 0x301 $reg1
          WriteR3BRegister 0x302 $reg2
          WriteR3BRegister 0x303 $reg3

          WriteR3BRegister 0x300 4   ;#  reset to load values
          WriteR3BRegister 0x300 0

          WriteR3BRegister 0x400 1   ;#  asic_val NOT => ts_fpga_reset

          set SBAK $SIDE
          foreach SIDE $SIDEList {

          set ABAK $ASIC
          foreach ASIC [set ASICList$SIDE] {

              set i 1    ;#  REG1
              WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] [set REG1.$SIDE.$ASIC]

          }
          set ASIC $ABAK
          }
          set SIDE $SBAK
      }

#        InsertLog "Time Stamp Reset complete"

      selectmodule $BAK  ;#  restore
   }

   proc do_SetExternalClock {} {
      global env
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

#    set clock source via CBS to external

          set z [catch {exec [file join $env(MIDASBASE) R3B CBS cbs.exe] -x -c} m]
          if {$z != 0} {InsertLog "$m"}

#    PLL disable   (to be confirmed)

#    Clk_sel to external 

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 | 2]
          WriteR3BRegister 0x400 $reg0

#    reset custom DCM

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 | 1]   ;#  reset
          WriteR3BRegister 0x400 $reg0
          set reg0 [expr $reg0 & 0xfe]    ;#   not reset
          WriteR3BRegister 0x400 $reg0

      }

      InsertLog "Clock source now set to external"

     selectmodule $BAK  ;#  restore

   }

   proc do_SetInternalClock {} {
      global env 
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

#    set clock source via CBS to internal

          set z [catch {exec [file join $env(MIDASBASE) R3B CBS cbs.exe] -i -c} m]
          if {$z != 0} {InsertLog "$m"}

#    PLL enable

          set z [catch {exec [file join $env(MIDASBASE) R3B PLL pll.exe] -s 0xe8 0x00 0x00 0x0a 0x20 0x01} m]
          if {$z != 0} {InsertLog "$m"}

#    Clk_sel to internal 

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 & 0xfd]
          WriteR3BRegister 0x400 $reg0

#    reset custom DCM

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 | 1]   ;#  reset
          WriteR3BRegister 0x400 $reg0
          set reg0 [expr $reg0 & 0xfe]    ;#   not reset
          WriteR3BRegister 0x400 $reg0


      }

      InsertLog "Clock source now set to internal"

      selectmodule $BAK  ;#  restore

   }
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS1000     {do_setOpt1000 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }
     do_redisplay

}   ;# end of if {$started == 0}




