
#    Note:  This is loaded into the namespace  TSCAN

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0
    
    variable temperatures ""
    variable T_log ""
    variable T_logfile "R3B4K_Temperatures.txt"
    variable T_logging 0
    variable T_run 0

    variable MaxTemp 50
    variable LowTemp 30
    variable HighTemp 50

	foreach item $::R3B::ModuleMenu {
#		InsertLog "Doing create for $item"
    		variable Opt900$item "___ No response"
     		variable Opt901$item "___ No response"
	}

   proc  show_variables {} {
       variable allmodules

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules"

          set rc [catch {ReadR3BRegister 0x00008000} m]
          if {$rc != 0} {InsertLog "$rc  $m"; return}
          InsertLog "$m"

   }
   
   proc START_TLOG {} {
        variable T_logging
   	   do_Twait start
	   set T_logging 1
   }
   
   proc STOP_TLOG {} {
    variable T_logging
	do_Twait stop
	set T_logging 0
   }
   
   proc do_Twait { n } {

	switch $n {
		start	{ puts "Starting temperature logging" ; set ::TSCAN::T_run 1 ; after 60 ::TSCAN::do_Twait run }
		run 	{ if { $::TSCAN::T_run == 0 } return ; do_Tlog ; after 60000 ::TSCAN::do_Twait run }
		stop	{ puts "Stopping temperature logging" ; set ::TSCAN::T_run 0 }
                default { InsertLog "Unknown command do_Twait $n"}
	}
   }
   	   
   proc do_Tlog {} {
   	   variable T_log
	   variable T_logfile
	   global env

   	   set BAK $::R3B::R3B4K   ;#   save

      foreach R3B4K $::R3B::ModuleMenu { 
	   set ::R3B::R3B4K $R3B4K
           set rc1 [catch {exec ping -c 1 $R3B4K} m1]
	   if { $rc1 == 0 } {do_READ}
	     set fname [file join $env(MIDASBASE) log $T_logfile ]
             set z [catch {open $fname a} fid]
	     if { $z != 0 }  { InsertLog "File open failed $fname: $fid " }
             set timestamp [clock format [clock seconds]]
             puts $fid "$timestamp $R3B4K $T_log"
             close $fid
      }
      set ::R3B::R3B4K $BAK   ;#   restore
  }

   proc do_redisplay {} {
# modify for the table showing different values for each R3B4K
     variable temperatures

      set BAK $::R3B::R3B4K   ;#   save

      foreach R3B4K $::R3B::ModuleMenu {
     		variable Opt900$R3B4K
     		variable Opt901$R3B4K 

	        set ::R3B::R3B4K $R3B4K

	 	set Opt900$R3B4K $R3B4K
		if { [ llength $::R3B::ModuleMenu ] == 1 } { ;# catch the only one module case 
           		set rc1 0
		} else {
			set rc1 [catch {exec ping -c 1 $R3B4K} m1]
		}
	        if { $rc1 == 0 } {
		   do_READ

		   set Opt900$R3B4K [ lindex $temperatures 0 ]
		   set Opt901$R3B4K [ lindex $temperatures 1 ]
		} else {
			
		   set Opt900$R3B4K "___ No response"
		   set Opt901$R3B4K "___ No response"
		}
      }

      set ::R3B::R3B4K $BAK   ;#   restore
   }

   proc do_collate_Temps {} {

	   variable T_logfile
	   global env

	     set fname [file join $env(MIDASBASE) log $T_logfile ]
             set fid [ open $fname r ] ; # open for read
    		set contents [read $fid ]
        	close $fid
		set records [ split $contents "\n"]
		set BAK $::R3B::R3B4K
     foreach R3B4K $::R3B::ModuleMenu {
	     set ::R3B::R3B4K $R3B4K
	     set virtex {}
	     set psu {}
	     set asic {}
		foreach t_list $records {
			if { [lindex $t_list 6 ] == $R3B4K } {
				lappend virtex [ lindex $t_list 7 ] 
				lappend psu [ lindex $t_list 8 ] 
				lappend asic [ lindex $t_list 9 ] 
			}
		}
		set virtex_length [ llength $virtex ]
		set max 0
		set min 100
		set sum 0
		for { set i 20 } { $i < 80 } { incr i } { set hist$i 0 }
		foreach val $virtex  {
			set sum [ expr $sum + $val ]

			if { $val > $max } { set max $val }
			if { $val < $min } { set min $val }
			set val [ expr int($val) ] 
			set hist$val [ expr [ set hist$val ] +  1 ]
		}
		set avg [ expr $sum / $virtex_length ] 
		InsertLog "$R3B4K => Virtex length: $virtex_length | average : $avg | max : $max | min : $min "
		set result {}
		for { set i 20 } { $i < 80 } { incr i } { lappend result [ set hist$i] }
		InsertLog "Histogram => $result "
		set psu_length [ llength $psu ]
		set max 0
		set min 100
		set sum 0 
		foreach val $psu {
			set sum [ expr $sum + $val ] 
			if { $val > $max } { set max $val }
			if { $val < $min } { set min $val }
		}
		set avg [ expr $sum / $psu_length ] 
		InsertLog "$R3B4K => PSU length: $psu_length | average : $avg | max : $max | min : $min "
		set asic_length [ llength $asic ]
		set max 0
		set min 100
		set sum 0 
		foreach val $asic {
			set sum [ expr $sum + $val ] 
			if { $val > $max } { set max $val }
			if { $val < $min } { set min $val }
		}
		set avg [ expr $sum / $asic_length ] 
		InsertLog "$R3B4K => ASIC length: $asic_length | average : $avg | max : $max | min : $min "
	}
		set ::R3B::R3B4K $BAK
}

   proc do_CAL {} {
       global env

     set BAK $::R3B::R3B4K
     foreach R3B4K $::R3B::ModuleMenu {
          set ::R3B::R3B4K $R3B4K
          set rc [catch {ReadR3BRegister 0x00008001} m]
          if {$rc != 0} {InsertLog "$rc  $m"; return}
          InsertLog "$m"
     }
     set ::R3B::R3B4K $BAK
   }

   proc do_READ {} {
       global env
   	variable T_log
	variable temperatures
    	variable HighTemp
        variable LowTemp
        variable MaxTemp

        set response ""

          set rc [catch {ReadR3BRegister 0x00008000} m]
          if {$rc != 0} {InsertLog "$rc  $m"; return}

          set vl0 0; set vl1 0

          foreach line [split $m "\n"] {
             if {[string equal -length 21 "pt100_0 temperature =" $line] == 1} {
                 set vl0 [string range $line 22 end]}
             if {[string equal -length 21 "pt100_1 temperature =" $line] == 1} {
                 set vl1 [string range $line 22 end]}
          }

	if { $vl0 <= $HighTemp } {
		lappend response "<font color=green>$vl0<\/font>"
	} else {
		lappend response "<font color=red>$vl0<\/font>"
	}

	if { $vl1 <= $HighTemp } {
		lappend response "<font color=green>$vl1<\/font>"
	} else {
		lappend response "<font color=red>$vl1<\/font>"
	}


        set temperatures $response
        set T_log "$vl0 $vl1"

   }

   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::R3B::R3B4K $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   CAL      {do_CAL}
                   READ     {do_READ}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

#    do_redisplay

}   ;# end of if {$started == 0}




