
#    RunControl specific for R3B Project

global env

namespace eval DataAcquisition {
     variable PROJECT; if {![info exists PROJECT]} {set PROJECT R3B}
     variable ACQSERVERS; if {![info exists ACQSERVERS]} {set ACQSERVERS $env(ComputerName)}
     variable ACQSERVER; if {![info exists ACQSERVER]} {set ACQSERVER [first $ACQSERVERS]}
}

namespace eval $::DataAcquisition::PROJECT {
    variable DBRootName; if {![info exists DBRootName]} {set DBRootName [file join EXPERIMENTS $::DataAcquisition::PROJECT]}
    variable DBNodeBase; if {![info exists DBNodeBase]} {set DBNodeBase 2013}
    variable DBNodeName; if {![info exists DBNodeName]} {set DBNodeName $env(ComputerName)}
}

puts "loading tcl/R3BRunControl.tcl for namespace [namespace current]"

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0


  if {[llength $::DataAcquisition::ACQSERVERS] > 1} {

    set z [catch {package require RunControlClient} m]
    if {$z != 0} {puts "RunControlClient returned z=$z and $m"} else {puts "RunControlClient loaded"}

    set f [file join $env(MIDASBASE) TclHttpd Html R3B RunControl stats.defn.tcl]
    if {[file exists $f]} {
#    note that reading this defines the elements of the ITEM array
        set z [catch {source $f} m]
    }

namespace eval DataAcquisitionControl {
     variable PostSetup_Exists 1
     variable PreReset_Exists 1

   proc do_PreReset {} {
      variable INFO

      return 0
   }   ;# end of do_PreReset


   proc do_PostSetup {} {

      return 0
   }    ;#  end of do_PostSetup

}   ;#  end of namespace eval DataAcquisitionControl

  } else {

#   for the case  llength $::DataAcquisition::ACQSERVERS == 1

    set z [catch {package require RunControlServer} m]
    if {$z != 0} {puts "RunControlServer returned z=$z and $m"} else {puts "RunControlServer loaded"}


#    provides the following 

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


   global env

     set f [file join $env(MIDASBASE) TclHttpd Html RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "RunControl returned z=$z and $m"} else {puts "RunControl loaded"}

     set f [file join $env(MIDASBASE) TclHttpd Html R3B RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "R3B RunControl returned z=$z and $m"} else {puts "R3B RunControl loaded"}

  }

global MIDAS_R3BRunControl_Exists
set MIDAS_R3BRunControl_Exists 1

package provide R3BRunControl 1.0
